//
#ifndef _config_h_
#define _config_h_

#define  COMMOTION_ADDR  0x06  //адрес I2C ComMotion
#define  MULTISERVO_ADDR  0x47  //адрес I2C MultiServo

#define _sMRTU_Baudrate  9600 //заданная скорость обмена
#define _sMRTU_Timeout_4 ( (1000/9600)* 10 * 4)
//при выбранных вариантах комптляция для соответствующего теста

/*
***************
Параметры для
ModbusRTU
***************
*/
//адрес устройства Modbus RTU
#define  _MRTU_Addr  1  
//ComMotiod drivers for 4 motors
#define _ComMotion_RMS  0x30  //первый (стартовый) регистр значения приводов
#define _ComMotion_SzRM  0x04  //колтчество регистров
//Multisero
#define _Multiservo_RSS1  0x40  //первый стартовый регистр значения сервоприводов
#define _Multiservo_SzRS  18  //количество регистров Multiservo

/*
******************************
Параметры для работы I2C
******************************
*/
#define _t2_i2c_interval  1000

/*
***************
* ComMotion *
***************
*/
#define _BC_Configuration  0    //применить конфигурарование при запуске
#define _BC_i2c_mode      0
#define _BC_demo_mode  1

#define  _BC_lovbat            60

#define _BC_3omni_conf    0x00
#define _BC_4omni_conf    0x01
#define _BC_mecan_conf    0x02
#define _BC_individ_conf    0x03
#define _BC_no_enc_conf    0x10
#define _BC_config             (_BC_individ_conf | _BC_no_enc_conf)

#define _BC_M1_Imax        250
#define _BC_M2_Imax        250
#define _BC_M3_Imax        250
#define _BC_M4_Imax        250

#define _BC_i2c_nooffset  0

#define _cmtest_min          -255
#define _cmtest_max         255

#define MOTOR_COUNT  4

#define _CM_M1_def  0
#define _CM_M2_def  0 
#define _CM_M3_def  0 
#define _CM_M4_def  0 

/*
**************
* Multiservo *
**************
*/
#define SERVO_COUNT 	18
//работать со всеми сервомашинами ?
#define _SERVO_ALL	0


typedef struct _MS
{
  int  pos[SERVO_COUNT];
} MS;
extern MS  multiservo;


#define _msconfig  1

//минимальные значения PWM
//исходя из параметров сервы
const uint16_t  pwm_min[] =
{
    490,  //0 - Поворот камеры
    490,  //1 - Подъём камеры
    490,  //2
    490,  //3
    490,  //4
    490,  //5
    490,  //6
    490,  //7
    490,  //8
    490,  //9
    490,  //10
    490,  //11
    490,  //12
    490,  //13
    490,  //14
    490,  //15
    490,  //16
    490   //17
};

//минимальные значение позиционирования
//исходя из параметров сервы
const int16_t  pos_min[] =
{
    -100,  //0  - поворот камеры
    -180,    //1  - подъём камеры
    -180,  //2
    -180,  //3
    -180,  //4
    -180,  //5
    -180,  //6
    -180,  //7
    -180,  //8
    -180,  //9
    -180,  //10
    -180,  //11
    -180,  //12
    -180,  //13
    -180,  //14
    -180,  //15
    -180,  //16
    -180   //17
};

//минимальные рабочие ограничения
//позиционирования
const int16_t  wpos_min[] =
{
    -90,  //0  - поворот камеры
    -45,    //1  - подъём камеры
    -180,  //2
    -180,  //3
    -180,  //4
    -180,  //5
    -180,  //6
    -180,  //7
    -180,  //8
    -180,  //9
    -180,  //10
    -180,  //11
    -180,  //12
    -180,  //13
    -180,  //14
    -180,  //15
    -180,  //16
    -180   //17
};

//максимальные значения PWM
//исходя из параметров сервы
const uint16_t  pwm_max[] =
{
    2400,  //0 - Поворот камеры
    2400,  //1 - Подъём камеры
    2400,  //2
    2400,  //3
    2400,  //4
    2400,  //5
    2400,  //6
    2400,  //7
    2400,  //8
    2400,  //9
    2400,  //10
    2400,  //11
    2400,  //12
    2400,  //13
    2400,  //14
    2400,  //15
    2400,  //16
    2400   //17
};

//максимальные значение позиционирования
//исходя из параметров сервы
const int16_t  pos_max[] = 
{
    100,  //0  - поворот камеры
    180,  //1  - подъём камеры
    180,  //2
    180,  //3
    180,  //4
    180,  //5
    180,  //6
    180,  //7
    180,  //8
    180,  //9
    180,  //10
    180,  //11
    180,  //12
    180,  //13
    180,  //14
    180,  //15
    180,  //16
    180   //17
};

//максимальные рабочие ограничения
//позиционирования
const int16_t  wpos_max[] =
{
    90,  //0  - поворот камеры
    90,    //1  - подъём камеры
    180,  //2
    180,  //3
    180,  //4
    180,  //5
    180,  //6
    180,  //7
    180,  //8
    180,  //9
    180,  //10
    180,  //11
    180,  //12
    180,  //13
    180,  //14
    180,  //15
    180,  //16
    180   //17
};

//коррекция нуля
const int16_t null_pos[] = 
{
  -1,  //0 - поворот камеры
  0,  //1 - подъём камеры
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0
};

#endif


